﻿//program 4
//04/23/2019
//M9460

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Program_4
{
    class GroundPackage
    {   //declaring variables(backing fields)  
        const double SIZE_COST_FACTOR=0.25;
        const double WEIGHT_COST_FACTOR = 0.45;
        private int _originZipCode;
        private int _destinZipCode;
        private double _length;
        private double _width;
        private double _height;
        private double _weight;

        public int OriginZipCode
        {    // Precondition:  None
            // Postcondition: originZipCode is returned
            get { return _originZipCode; }
            // Precondition:  value >= 00000 && value <= 99999
            // Postcondition: originZipCode # is set to the specified value
            set
            {
                if (value >= 00000 && value <= 99999)
                    _originZipCode = value;
                else // When invalid, set to 0 instead
                    _originZipCode = 40202;
                }
        }
        // DestinZipCode property 
        public int DestinZipCode
        {   // Precondition:  None
            // Postcondition: destinZipCode is returned
            get { return _destinZipCode; }
            // Precondition:  value >= 00000 && value <= 99999
            // Postcondition: destinZipCode # is set to the specified value
            set
            {
                if (value >= 00000 && value <= 99999)
                    _destinZipCode = value;
                else // When invalid, set to 0 instead
                    _destinZipCode = 90210;
            }
        }
        // Length property 
        public double Length
        {   // Precondition:  None
            // Postcondition: length is returned
            get { return _length; }
            // Precondition:  value > 0
            // Postcondition: length # is set to the specified value
            set
            { if (value > 0)
                    _length = value;
                else _length = 1.0;
            }
        }
        // Width property 
        public double Width
        {   // Precondition:  None
            // Postcondition: width is returned
            get { return _width; }
            // Precondition:  value > 0
            // Postcondition: width # is set to the specified value
            set
            {
                if (value > 0)
                    _width = value;
                else _width = 1.0;
               }
        }
        // Height property 
        public double Height
        {    // Precondition:  None
            // Postcondition: height is returned
            get { return _height; }
            // Precondition:  value > 0
            // Postcondition: height # is set to the specified value
            set
            {
                if (value > 0)
                    _height = value;
                else _height = 1.0;

               }
        }
        // Weight property 
        public double Weight
        {   // Precondition:  None
            // Postcondition: weight is returned
            get { return _weight; }
            // Precondition:  value > 0
            // Postcondition: weight # is set to the specified value
            set
            {
                if (value > 0)
                    _weight = value;
                else _weight = 1.0;
                }
        }
        // ZoneDistance property 
        public int ZoneDistance
        {
            get {return Math.Abs((OriginZipCode/10000)-(DestinZipCode/10000)); }
        }
        //instance variables 
        public GroundPackage(int Ozip, int Dzip, double len, double wid, double high, double weit)
        {
            OriginZipCode = Ozip;
            DestinZipCode = Dzip;
            Length = len;
            Width = wid;
            Height = high;
            Weight = weit;
        }
        public double CalcCost()
        {
            double Cost = SIZE_COST_FACTOR * (Length + Width + Height) + WEIGHT_COST_FACTOR * (ZoneDistance + 1) * (Weight);
            return Cost;
        }
        // Precondition:  None
        // Postcondition: A string is returned presenting the result 
        public override string ToString() // override is required!
        {
            string result;
            result = $"Origin Zip Code: {OriginZipCode}{Environment.NewLine}Destination Zip Code: {DestinZipCode}{Environment.NewLine}Length: {Length}{Environment.NewLine}Width: {Width}{Environment.NewLine}Height: {Height}{Environment.NewLine}Weight: {Weight} ";
            return result;

        }
    }
}
